
;          Ŀ
;            RES - remote control system      (C) Oto Valek       
;          

.286

;----------------------------------------------------------------- KONSTANTY

  sckt1  = 4440h                    ; socket pro prijem prikazu
  scrsckt= 4441h                    ; socket pro vysilani (mj. obrazovky)
  hsize  = 10                       ; velikost hlavicky naseho protokolu
                                    ; velikost programu pro ponechani v pameti
  Size16 = (offset begin - offset _TEXT + 15) shr 4
                                    ; (v nasobcich 16 bytu - parametr pro KEEP)
  Ctrl_Enter =10                    ; specialni kod kombinace Ctrl-Enter

;--------------------------------------------------------------- TYPY PAKETU
  ScrSave    = 1                    ; paket s casti videopameti
  ScrError   = 2                    ; neznamy videomod
  ResetComp  = 3                    ; "hardwarovy" reset pocitace
  AskUser    = 4                    ; zobrazeni zpravy
  MapkaOn    = 5                    ; reserved
  AddToBuff  = 6                    ; vlozeni klaves do bufferu klavesnice
  Palette    = 7                    ; paleta videmodu 13h - nepouzito
  KeybLock   = 8                    ; zamknuti klavesnice
  KeybUnlock = 9                    ; odemknuti klavesnice
  BlankScr   =10                    ; zhasnuti obrazovky
  ShowScr    =11                    ; rozsviceni obrazovky
  AskProof   =12                    ; potvrzeni dosle zpravy
  Exclusive  =13                    ; zamknuti pro vyhradni ovladani - nepouzito
  PublicR    =14                    ; opetovne odemknuti - nepouzito
  RemoveTSR  =15                    ; odisntalovani rezidentniho programu
  AskFail    =16                    ; zprava nezobrazena (videomod)
  Asking     =17                    ; odpoved na paket prijaty behem zpravy
  CancelAsk  =18                    ; zruseni prave zobrazene zpravy
  Connect    =19                    ; informacni paket stale vysilany
  Refresh    =20                    ; obnovi posilani obrazovky na urcitou dobu
  CastIsOff  =21                    ; zprava nezobrazena (castoff) - nepouzito
  FDisabled  =22                    ; zablokovane diskove funkce - nepouzito
  Login      =23                    ; login na stanici - omezeno
  Logout     =24                    ; nepouzito
  AAllowed   =25                    ; odpoved na login - povoleno
  ADisabled  =26                    ; nepouzito
  ATimeout   =27                    ; nepouzito
  UninstFail =28                    ; odistalovani se nepovedlo

;-------------------------------------------------------------- STRUKTURA ECB

ECBt struc
      Link       dd    0            ; Link Address
      ESR        dd    0            ; ESR callback adresa
      InUse      db    0            ; In Use Flag - nenulove behem pouziti ECB
      ComplCode  db    0            ; Complection Code - navratovy kod
      socket     dw    0            ; socket pro prijem/vysilani
      IPXwspc    db    4  dup (0)   ; reserved
      DRVwspc    db    12 dup (0)   ; reserved
      ImmdAdr    db    6  dup (0FFh); cilova/vysilaci adresa v lok.siti
      FragCnt    dw    1h           ; pocet fragmentu
      FragDta    dw    0            ; adresa 1.fragmentu
                 dw    0
      FragSize   dw    ?            ; delka 1.fragmentu
      FragDta2   dw    0            ; adresa 2.fragmentu
                 dw    0
      FragSize2  dw    ?            ; delka 2.fragmentu
      FragDta3   dw    0            ; adresa 3.fragmentu
                 dw    0
      FragSize3  dw    ?            ; delka 3.fragmentu
ECBt ends

;------------------------------------------------------- STRUKTURA HLAVICKY IPX
IPXhead struc
      checksum   dw    0FFFFh       ; nepouzivano
      h_length   dw    0            ; delka vcetne hlavicky
      TransPCtrl db    0            ; reserved
      PacketType db    0            ; 0 - obecny paket
      DestNetw   db    4 dup (0)    ; cilova sit
      DestNode   db    6 dup (0FFh) ; cilova adresa
      DestSckt   dw    0            ; cilovy socket
      SrceNetw   db    4 dup (0)    ; zdrojova sit
      SrceNode   db    6 dup (0FFh) ; zdrojova adresa
      SrceSckt   dw    0            ; zdrojovy socket
IPXhead ends

;----------------------------------------- STRUKTURA HLAVICKY NASEHO PROTOKOLU
IDt struc
      verify     db    17           ; kontrola, zda jde o nas protokol
      typ        db    ?            ; typ paketu - viz konstanty
      ID1        db    ?            ; volitelne parametry
      ID2        db    ?
      ID3        db    ?
      ID4        db    ?
      Sec        dd    ?            ; security number
IDt ends

;---------------------------------------------------------- ZACATEK PROGRAMU

  STEJNESEG macro                   ; makro pro nastaveni stejnych
    mov ax,cs                       ; segmentovych registru (model TINY)
    mov ds,ax
    mov es,ax
  endm

_TEXT segment
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT

  org 100h
@filename:                          ; zacatek .COM programu
  jmp begin                         ; skok pres rezidentni cast

;---------------------------------------------------------- REZIDENTNI DATA

  _Stack      db 128 dup (?)        ; zasobnik rezidentniho procesu
EndStack:
                                    ; EVENT CONTROL BLOCK pro prijem
  ECBr        ECBt    <,,,,,,,,1h,offset headr,,>
  headR       IPXhead <>            ; hlavicka paketu IPX pro prijem
  IDR         IDt     <>            ; hlavicka naseho protokolu & data
  dataR       db 1496-30-hsize dup (?)
                                    ; EVENT CONTROL BLOCK pro odesilani
  ECBS        ECBt    <,,,,,,,,1h,offset heads,,>
  headS       IPXhead <>            ; hlavicka paketu IPX pro odesilani
  IDS         IDt     <>            ; hlavicka naseho protokolu & data
  dataS       db 1496-30-hsize dup (?)
  ofs_1C      dw ?                  ; ulozeni adres puvodnich preruseni
  seg_1C      dw ?
  ofs_28      dw ?
  seg_28      dw ?
  ofs_2F      dw ?
  seg_2F      dw ?
  MY_ID       db 0                  ; ID programu pro registraci v INT 2Fh
  SecNum      dd 0                  ; unikatni nahodne cislo bezici instance
  busy        db 1                  ; prave probiha obsluha preruseni
  uvolnit     db 0                  ; prave ceka pozadavek na odistalovani
  SSeg        dw ?                  ; ulozena adresa Stacku preruseneho programu
  SPtr        dw ?
  LastPSP     dw ?                  ; posledni zjistena adresa PSP akt.procesu
  VideoMode   db ?                  ; aktualni videomod
  VideoPage   db ?                  ; aktualni videostranka
  VideoPageO  dw ?                  ; aktualni offset videostranka
  VideoC      dw 1                  ; ktery 500B kus obrazovky se prave posila
  TimCountLo  dw ?                  ; ulozene dolni slovo timeru BIOSu
  PrvCountLo  dw ?                  ; pro pouziti behem zobrazene zpravy
  ConnectTim  dw 0                  ; timeout pro posilani Connect paketu
  RefreshTim  dw 0                  ; timeout pro kontinualni posilani obrazovky
  Md          = 18                  ; delka zpravy ' Press Ctrl-Enter '
  MessText    db ' Press Ctrl-Enter '

;--------------------------------------------------- ZJISTENI VEKTORU PRERUSENI
getint proc near                    ; al - interrupt number
  push di                           ; es:bx - address
  push ax
  mov ah,0
  shl ax,2
  mov di,ax
  mov ax,0
  mov es,ax
  mov bx,word ptr es:[di]           ; primym zapisem do tabulky preruseni
  mov ax,word ptr es:[di+2]
  mov es,ax
  pop ax
  pop di
  ret
getint endp

;-------------------------------------------------- NASTAVENI VEKTORU PRERUSENI
setint proc near                    ; al - interrupt number
  push es                           ; ds:dx - address
  push di
  push ax
  mov ah,0
  shl ax,2
  mov di,ax
  mov ax,0
  mov es,ax
  mov word ptr es:[di],dx           ; primym zapisem do tabulky preruseni
  mov word ptr es:[di+2],ds
  pop ax
  pop di
  pop es
  ret
setint endp

;----------------------------------------------------------- VOLANI SLUZEB IPX
Net proc near
  push es                           ; nici registry ES:BP
  push si
  int 7Ah
  pop si
  pop es
  ret
Net endp

;-------------------------------------------------------------- POSLANI PAKETU
Posli proc near                     ; BX - velikost
  mov si,offset ECBs
  add bx,30                         ; zvysime delku o delku IPX hlavicky
  push bx                           
  mov bx,6                          ; sluzba IPX x. 6
  call net                          ; zruseni udalosti - stareho odeslani
  pop bx
  mov heads.DestSckt,Scrsckt        ; socket pro odesilani - do hlavicky paketu
  mov ECBs.Socket   ,Scrsckt        ; socket pro odesilani - do ECB
  mov ax,0FFFFh
  mov cx,6
  mov di,offset heads.DestNode      ; odesilame vsem - FFFFFFFFFFFFh
  cld
  rep stosb

  mov ax,0h                         ; odesilame do stejne site - 0000h
  mov cx,4
  mov di,offset heads.DestNetw
  rep stosb

  mov di,0                          ; paket k odeslani je delen
  mov cx,offset headS               ;  do frgamentu po 500b
  mov word ptr es:[ECBs.FragCnt ],0 ; zatim je fragmentu 0

DalsiFrag:
  cmp bx,500                        ; BX = zbyva k odeslani
  ja vetsi                          ; vetsi nez 500 B - odesleme 500 B
  mov ax,bx
  jmp zapis
vetsi:
  mov ax,500
Zapis:                              ; vyplneni adresy & velikosti fragmentu
  mov word ptr es:[ECBs.FragSize +di],ax
  mov word ptr es:[ECBs.FragDTA+2+di],ds
  mov word ptr es:[ECBs.FragDTA  +di],cx
  inc word ptr es:[ECBs.FragCnt  ]  ; zvyseni poctu fragmentu
  add di,6                          ; zvyseni offsetu
  add cx,ax
  sub bx,ax                         ; snizeni zbyvajici delky
  cmp bx,0
  jne DalsiFrag

  mov bx,3                          ; sluzba IPX c.3 - vyslani IPX paketu
  call Net
  ret
Posli endp

;------------------------------------ POSLANI JEDNODUCHE ZPRAVY - JEN HLAVICKA
SendIds proc near                   ; AL-typ zpravy
  mov IDs.verify,17                 ; overeni
  mov IDs.typ,al
  mov bx,hsize                      ; velikost hlavicky
  call posli                        ; odeslani
  ret
SendIds endp
;-------------------------------------------------- ASYNCHRONNI PRIJEM PAKETU
Prijem proc near
  mov si ,offset ECBr               ; vyplneni IPX EVENT CONTROL BLOCKu
  mov ECBr.FragSize ,1496           ; maximalni prijaty paket
  cmp ax ,0ABCDh                    ; AX=0ABCDh znamena omezeni delky na BX
  jne Max_length
  mov ECBr.FragSize ,bx
Max_length:
  mov ECBr.Socket   ,Sckt1          ; socket pro prijem
  mov ECBr.FragDTA+2,ds             ; adresa fragmentu je buffer pro prijem
  mov ECBr.FragDTA  ,offset headR
  mov ECBr.FragCnt  ,1              ; jen jeden fragment
  mov word ptr [offset ECBr+4],0    ; nulovani adresy ESR procedury
  mov word ptr [offset ECBr+6],0    ; => zadne asynchronni osetreni prijmu

  mov ax,0FFFFh                     ; Immediate Address = FFFFFFFFFFFFh
  mov cx,6                          ; => prijimame od kohokoliv
  mov di,offset ECBr.ImmdAdr
  cld
  rep stosb

  mov bx,4                          ; IPX fce 4 - pozadavek na prijem paketu
  call Net

  ret
Prijem endp
;----------------------------------------- VLOZENI KLAVES DO BUFFERU KLAVESNICE
AddKeys proc near
  push ds                           ; cteni stavovych slov klavesnice
  mov ax,0040h                      ; ze segmentu datove oblasti BIOSu
  mov ds,ax
  mov al,ds:[0017h]                 ; Stav1
  mov ah,ds:[0018h]                 ; Stav2
  mov bl,ds:[0096h]                 ; Stav3
  pop ds

  mov bh,IDr.ID2                    ; prijaty stav, ktery je treba nastavit
                                    ; nastaveni bitu ve stavovych slovech
  mov cl,bh                         ; Stav1
  and cl,0Fh
  and al,0F0h
  or al,cl

  mov cl,bh                         ; Stav2
  and cl,30h
  shr cl,4
  and ah,0FCh
  or ah,cl

  mov cl,bh                         ; Stav3
  and cl,0C0h
  shr cl,4
  and bl,0F3h
  or bl,cl

  push ds                           ; ulozeni stavovych slov zpet do pameti
  push ax
  mov ax,0040h
  mov ds,ax
  pop ax
  mov ds:[0017h],al                 ; Stav1
  mov ds:[0018h],ah                 ; Stav2
  mov ds:[0096h],bl                 ; Stav3
  pop ds
  mov dh,IDr.ID1
  cmp dh,0                          ; je pocet klaves nulovy ?
  je AKend                          ; => konec
  shr dh,1
  mov bx,0
dalsiK:
  mov cl,[dataR+bx  ]               ; CX = dalsi prijata klavesa
  mov ch,[dataR+bx+1]
  mov ah,05h                        ; vlozeni do bufferu klavesnice
  int 16h                           ; funkci BIOSu
  add bx,2                          ; zvyseni offsetu do bufferu
  dec dh
  cmp dh,0                          ; pocitadlo cyklu
  jne dalsiK
AKend:
  ret
AddKeys endp
;--------------------------------------------------- ZOBRAZENI DOSLE ZPRAVY
Zprava proc near
  mov al,AskProof                   ; Potvrzeni o prijmu
  call SendIds
  push ds                           ; Uschova obrazovky (do datove casti paketu)
  mov ax,VideoPageO
  shr ax,4
  add ax,0B800h
  mov ds,ax
  mov si,2*160                      ; Uschova od druheho radku
  mov di,offset [dataR+100]
  mov cx,3*160                      ; Uschova tri radku
  cld
  rep movsb
  pop ds

  mov ah,byte ptr dataR             ; priprava vypsani zpravy
  mov al,ah
  cmp ah,Md                         ; pokud je prilis kratka, prodlouzime
  jae delsiM
  mov ah,Md
delsiM:
  mov dx,ax                         ; vypocet x-souradnic kraju ramecku
  push ax
  shr ah,1                          ; polovina delky zpravy
  mov cl,38
  sub cl,ah                         ; CL=levy okraj
  mov ch,42
  add ch,ah                         ; CH=pravy okraj
  mov dh,ch
  sub dh,cl                         ; DH=sirka ramecku
  pop ax

  push es                           ; nakresleni ramecku
  mov ax,VideoPageO
  shr ax,4
  add ax,0B800h
  mov es,ax                         ; ES=segment obrazovky
  mov bx,0
  mov ah,byte ptr ds:[IDr.ID1]      ; AH=je barva zpravy (z dosleho paketu)

  mov bl,cl                         ; levy okraj ramecku pro nasledujici 3 znaky
  shl bl,1                          ; dvojnasobek souradnice

  mov al,''                        ; levy horni roh
  mov word ptr es:[320+bx],ax

  mov al,''                        ; leva hrana
  mov word ptr es:[480+bx],ax

  mov al,''                        ; levy dolni roh
  mov word ptr es:[640+bx],ax

  mov bl,ch                         ; pravy okraj ramecku pro nasledujici 3 znaky
  shl bl,1                          ; dvojnasobek souradnice

  mov al,''                        ; pravy horni roh
  mov word ptr es:[320+bx],ax

  mov al,''                        ; prava hrana
  mov word ptr es:[480+bx],ax

  mov al,''                        ; pravy dolni roh
  mov word ptr es:[640+bx],ax

  push cx                           ; vodorovne hrany
  mov al,''
  inc cl                            ; vypocet delek a souradnic
  shl cl,1
  mov di,320                        ; vypocet offsetu pro horni hranu
  mov ch,0
  add di,cx
  push cx                           ; offset od leveho kraje (vybere se jako SI)
  mov cl,dh                         ; CL=rozdil souradnic
  dec cx                            ; CX=delka ramecku (o 1 nizsi)
  push cx                           ; ulozeni delky
  cld
  rep stosw                         ; nakresleni horni hrany
  pop cx                            ; obnova delky
  mov di,640                        ; vypocet offsetu pro dolni hranu
  pop si                            ; obnova offsetu od leveho kraje
  add di,si
  rep stosw                         ; nakresleni dolni hrany
  pop cx

  pop es

  push dx                           ; vypis 'Press Ctrl-Enter' - funkci BIOSu
  push cx
  mov ah,13h
  mov al,0
  mov bp,offset MessText            ; ES:BP=retezec
  mov dh,4                          ; DH=radek
  mov dl,cl
  add dl,2                          ; DL=sloupec
  mov cx,Md                         ; CX=delka
  mov bl,IDr.ID1                    ; BL=barva
  mov bh,VideoPage                  ; BH=videostranka
  int 10h
  pop cx
  pop dx

  push cx                           ; doplneni zpravy mezerami
  mov byte ptr DataR,' '
  mov ax,0
  mov al,dl
  mov di,ax
  mov al,' '
  add di,offset [DataR+1]
  mov cx,0
  mov cl,dh
  sub cl,dl
  rep stosb
  pop cx

  mov ah,13h                        ; vypis samotne zpravy - funkci BIOSu
  mov al,0
  mov bp,offset DataR               ; ES:BP=retezec
  mov dl,cl
  inc dl                            ; DL=sloupec
  mov cx,0
  mov cl,dh
  dec cl                            ; CX=delka
  mov dh,3                          ; DH=radek
  mov bl,IDr.ID1                    ; BL=barva
  mov bh,VideoPage                  ; BH=videostranka
  int 10h

Mess_prijem:                        ; zprava je zobrazena 

  mov ax,0ABCDh                     ; omezeni delky prijmu - buffer je pouzit
  mov bx,80+30+6                    ;  k uschove obrazovky
  call prijem                       ; AX=0ABCDh znamena omezeni delky na BX

Znovu:                              ; smycka behem zobrazene zpravy
  cmp byte ptr cs:[ECBr.InUse],0    ; Prisel paket ?

  jne mess_tk                       ; ne - dal
  mov dx,0
  cmp IDr.typ,AddToBuff             ; Prisel paket s klavesami ?
  jne dal1
  cmp byte ptr Datar,Ctrl_Enter     ; A je to klavesa Ctrl-Enter ?
  je MessCancelled                  ; Tak zrusime zpravu
dal1:
  cmp IDr.typ,CancelAsk             ; Prisel paket s pozadavkem zruseni ?
  je MessCancelled
  cmp IDr.typ,AskUser               ; Prisla dalsi zprava ?
  mov dx,0CCCCh                     ; opustime proceduru a nechame se
  je MessCancelled                  ;  zavolat znovu
  mov dx,0
  mov al,Asking                     ; Prislo neco jineho
  call SendIds                      ; Posleme zpet chybu "je zobrazena zprava"
  jmp Mess_prijem

Mess_tk:                            ; Posilani obrazovky pri zobrazene zprave
  call GetModes                     ; zjisteni videomodu
  mov ax,PrvCountLo
  cmp TimCountLo,ax
  je neposliSS                      ; jen jednou za tik timeru
  mov ax,TimCountLo
  mov PrvCountLo,ax                 ; posledni hodnotu ukladame do PrvCountLo
  call SSend
neposliSS:
  mov ah,01h                        ; byla mezitim stisknute klavesa ?
  int 16h
  je znovu                          ; ne - smycka pokracuje
  mov ah,00h                        ; ano - precteme ji
  int 16h
  cmp al,Ctrl_Enter                 ; je to Ctrl-Enter ?
  jne znovu                         ; ne - smycka pokracuje

MessCancelled:
  push es                           ; Obnova uschovane obrazovky
  mov ax,VideoPageO
  shr ax,4
  add ax,0B800h
  mov es,ax
  mov di,2*160
  mov si,offset [dataR+100]
  mov cx,3*160
  cld
  rep movsb
  pop es
  ret
Zprava endp

;--------------------------------------------------- ZPRACOVANI DOSLEHO PAKETU
Paket proc near
  cmp IDr.verify,17                 ; skutecne od SHOW
  je dalP2
  jmp endpak
dalP2:

  cmp IDr.typ,Login                 ; pokus o login
  je _Login

  mov si,offset Idr.Sec             ; Spravne Security ID ?
  mov di,offset SecNum
  mov cx,4
  cld
  repe cmpsb                        ; porovnani
  cmp cx,0
  je ZpracujP
  jmp endpak                        ; ne - pryc

ZpracujP:
  cmp IDr.typ,Refresh               ; [case] podle cisla paketu
  je _Refresh
  cmp IDr.typ,AddToBuff
  je _AddToBuff
  cmp IDr.typ,ResetComp
  je _ResetComp
  cmp IDr.typ,KeybLock
  je _KeybLock
  cmp IDr.typ,KeybUnLock
  je _KeybUnlock
  cmp IDr.typ,BlankScr
  je _BlankScr
  cmp IDr.typ,ShowScr
  je _ShowScr
  cmp IDr.typ,AskUser
  je _AskUser
  cmp IDr.typ,RemoveTSR
  je _RemoveTSR
  jmp endpak                        ; [endcase]


_Login:                             ; pokus o login
  mov IDs.typ,AAllowed              ; v teto verzi automaticky uspech
  mov ax,word ptr SecNum            ; posilame zpet Security ID
  mov word ptr IDs.Sec,ax
  mov ax,word ptr [SecNum+2]
  mov word ptr [IDs.Sec+2],ax
DalR:
  mov bx,hsize+4
  mov dx,0
  mov IDs.verify,17
  call posli                        ; poslani odpovedi
  jmp endpak

_refresh:                           ; paket udrzujici posilani obrazovky
  mov RefreshTim,120*18             ; prodlouzeno o cca 2 minuty
  jmp endpak

_AddToBuff:                         ; stisknute klavesy
  call AddKeys                      ; vlozeni klaves do bufferu
  jmp endpak

_ResetComp:                         ; reset pocitace
  db 0EAh,0F0h,0FFh,000h,0F0h       ; (hardwarovy)

_KeybLock:                          ; zamknuti klavesnice
  mov al,0F5h                       ; (zapisem na port)
  out 60h,al
  jmp endpak

_KeybUnlock:                        ; odemknuti klavesnice
  mov al,0F4h
  out 60h,al
  jmp endpak

_BlankScr:                          ; zhasnuti obrazovky
  mov	ax,1201h
  mov	bl,36h
  int	10h                         ; funkce video BIOSu
  jmp endpak

_ShowScr:                           ; opetovne rozsviceni obrazovky
  mov	ax,1200h
  mov	bl,36h
  int	10h
  jmp endpak

_AskUser:                           ; pozadavek na zobrazeni zpravy

  cmp VideoMode,3                   ; lze jen v textovem rezimu

  je Zobraz

  mov al,AskFail                    ; jinak - posleme chybu zpet
  call SendIds

  jmp endpak

Zobraz:
  call zprava                       ; zobrazeni zpravy

  cmp dx,0CCCCh                     ; zavolame zpravu znovu (prisla dalsi)
  je Zobraz

  jmp endpak

_RemoveTSR:                         ; pozadavek na odinstalovani rezidenta
  mov uvolnit,1
  jmp endpak

EndPak:
  call prijem
  ret
Paket endp

;----------------------------------------------- POSILANI "KONTAKTNIHO" PAKETU
SendConnect proc near
  mov IDs.verify,17                 ; vyplneni hlavicky paketu
  mov IDs.typ,Connect
  mov al,VideoMode
  mov IDs.ID1,al                    ; IDs.ID1=videomod
  mov IDs.ID2,2                     ; IDs.ID2=pocet 500B bloku
  push ds
  mov ax,word ptr cs:[LastPSP]      ; data paketu - jmeno zrovna bezici aplikace
  dec ax
  mov ds,ax
  mov si,8
  mov di,offset dataS
  mov cx,8                          ; osmiznakove jmeno
  cld
  rep movsb

  mov bx,hsize+8                    ; velikost = hlavicka+8
  pop ds
  call posli
  mov ConnectTim,2*18               ; dalsi paket az za cca 2 vteriny
  ret
SendConnect endp

;-------------------------------------------------------- POSILANI VIDEOMODU
SendScr proc near
  mov al,VideoMode
  mov IDs.ID1,al                    ; IDs.ID1=videomod
  mov IDs.ID2,2                     ; IDs.ID2=pocet 500B bloku
  cmp VideoMode,3                   ; jen textovy mod 80x25x16 barev podporovan
  jne UnknownMode
  add VideoC,2                      ; posilame dalsi 2 bloky 500 bytu
  cmp VideoC,8                      ; konec obrazovky ?
  jbe nesnizC
  mov VideoC,1                      ; => od zacatku
nesnizC:
  mov IDs.typ,ScrSave               ; IDs.typ paketu
  mov ax,VideoC
  mov word ptr IDs.ID3,ax           ; IDs.ID3 cislo paketu

  push ds                           ; kopie prislusne casti obrazovky do
  mov si,VideoPageO                 ;  datove casti paketu
  mov si,0
  mov ax,VideoC
  dec ax
  mov bx,500
  mul bx
  add si,ax
  mov ax,0B800h
  mov ds,ax
  mov di,offset DataS
  mov cx,1000
  cld
  rep movsb
  pop ds

  mov ah,3                          ; na konci paketu - udaje o kursoru
  mov bh,0
  int 10h
  inc dl                            ; x
  inc dh                            ; y
  mov [dataS+1000],dl               ; X - Posice kursoru
  mov [dataS+1001],dh               ; Y -
  mov [dataS+1002],ch               ; Pocatecni linka
  mov [dataS+1003],cl               ; Koncova linka

  mov bx,hsize+1000+4               ; delka paketu - parametr pro posli
  mov IDs.verify,17                 ; kontrolni znak
  call posli

EndSS:
  ret
UnknownMode:
  mov al,ScrError                   ; odesleme chybu - neznamy videomod
  call SendIds
  ret
SendScr endp
;-------------------------------------------------------- ZJISTENI VIDEOMODU
Getmodes proc near
  push ds                            
  mov ax,0040h
  mov ds,ax
  mov al ,byte ptr ds:[0049h]       ; informace z datove oblasti BIOSu
  mov cs:[VideoMode],al             ; zjistime videomod
  mov al ,byte ptr ds:[0062h]
  mov cs:[VideoPage],al             ; stranku
  mov ax ,word ptr ds:[004Eh]
  mov cs:[VideoPageO],ax            ; offset stranky
  mov ax ,word ptr ds:[006Ch]
  mov cs:[TimCountLo],ax            ; timer BIOSu
  pop ds
  ret
Getmodes endp
;---------------------------------------------------- PRAVIDELNE POSILANI DAT
SSend proc near

  cmp ConnectTim,0                  ; paket Connect posilame jednou za cas
  jne snizC
  call SendConnect
  ret                               ; ale pak uz neposilame obrazovku
snizC:
  dec ConnectTim

  cmp RefreshTim,0                  ; "nedavno" byl prijat paket Refresh
  je nesnizR
  call SendScr                      ; => posli obrazovku
  dec RefreshTim                    ; sniz pocitadlo
nesnizR:
  ret
SSend endp
;--------------------------------- VYKONNA OBSLUHA INT 1Ch - user safe timer
Active1C proc near

  call GetModes                     ; zjistit aktualni videomod

  cmp byte ptr cs:[ECBr.InUse],0    ; Prisel paket ?
  jne neprislo

  call paket                        ; zpracovani paketu

  jmp konec
neprislo:

  call SSend                        ; Posli Connect nebo obrazovku

konec:
  ret
Active1C endp

;----------------------------------------- OBSLUHA INT 1Ch - user safe timer
Int1C proc far
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT
  pushf                             ; Zavolam puvodni obsuhu
  call dword ptr cs:[ofs_1C]
  cmp cs:[Busy],1                   ; Nebezim uz ?
  je nic1C
  push ax
  mov cs:[busy],1                   ; Prepnu zasobnik
  mov cs:[SSeg],ss
  mov cs:[SPtr],sp
  mov ax,cs
  cli
  mov ss,ax
  mov sp,offset cs:[ENDSTACK]
  sti
  push ds                           ; Uschovam do nej registry
  push es
  push si
  push di
  push dx
  push cx
  push bx
  push bp
  mov bp,sp
  STEJNESEG

  sti
  mov al,20h
  out 20h,al

  call active1C                     ; Hlavni procedura

  pop bp
  pop bx                            ; Obnovim registry
  pop cx
  pop dx
  pop di
  pop si
  pop es
  pop ds
  cli                               ; Zasobnik zpet
  mov ss,cs:[SSeg]
  mov sp,cs:[SPtr]
  sti
  pop ax
  mov cs:[Busy],0
nic1C:
  iret
Int1C endp
;--------------------------------- VYKONNA OBSLUHA INT 28h - DOS safe
Active28 proc near
  cmp uvolnit,1                     ; prisel mezitim prikaz k odinstalovani ?
  jne GetPSP
  call uvolni                       ; pokus o odinstalovani
  mov uvolnit,0
  jb End_a28
  mov al,UninstFail                 ; nelze - posleme zpet chybu
  mov IDs.ID1,bl                    ; i s cislem preruseni
  call SendIds
End_a28:
  ret
GetPSP:                             ; uschovame PSP procesu, ktery bezi
  mov ah,62h                        ;  pro pozdejsi odesilani jeho nazvu
  int 21h                           ;  siti ( tuto fci neni bezpecne volat 
  mov word ptr cs:[LastPSP],bx      ;   jindy nez ted )

  ret
Active28 endp
;----------------------------------------- OBSLUHA INT 28h - DOS idle
Int28 proc far
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT
  cmp cs:[Busy],1                   ; Nebezim uz ?
  je nic28
  push ax
  mov cs:[busy],1                   ; Prepnu zasobnik na svuj
  mov cs:[SSeg],ss
  mov cs:[SPtr],sp
  mov ax,cs
  cli
  mov ss,ax
  mov sp,offset cs:[ENDSTACK]
  sti
  push ds                           ; Uschovam do nej registry
  push es
  push si
  push di
  push dx
  push cx
  push bx
  push bp
  mov bp,sp
  STEJNESEG

  call active28                     ; Hlavni procedura

  pop bp
  pop bx                            ; Obnovim registry
  pop cx
  pop dx
  pop di
  pop si
  pop es
  pop ds
  cli                               ; Zasobnik zpet
  mov ss,cs:[SSeg]
  mov sp,cs:[SPtr]
  sti
  pop ax
  mov cs:[Busy],0
nic28:

  jmp dword ptr cs:[ofs_28]
Int28 endp

;----------------------------------------- OBSLUHA INT 2Fh - DOS multiplex
Int2f proc far
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT
  cmp ah,cs:[MY_ID]                 ; test, zda je dotaz pro tento program
  je pro_me
  jmp dword ptr cs:[ofs_2F]         ; jinak predat dalsimu v retezci

Pro_me:

  push ax                           ; uschova pouzitych registru 
  push ds                           ; poradi je dulezite !
  push es
  push si
  push di
  push dx
  push cx
  push bx
  push bp
  mov bp,sp

  cmp al,0                          ; povinna fce 0 - kontrola pritomnosti
  je kontrola
  cmp al,77h                        ; prikaz k odinstalovani sebe sama
  je uvolni_2F
  jmp konec_2f

Kontrola:                           ; povinna fce 0 - kontrola pritomnosti
;  mov al,0FFh
;  mov bx,3333h
  mov ss:[bp+16],0FFFFh             ; AX na zasobniku - indikace obsazeni
  mov ss:[bp+2],3333h               ; BX na zasobniku - moje unikatni cislo
  jmp konec_2f

Uvolni_2F:
  call uvolni
  mov ss:[bp+2],BX                  ; BX ( neuvolneno - BL - cislo preruseni)
  jae konec_2f
  mov ss:[bp+2],3334h               ; BX ( uvolneno )
  jmp konec_2f

Konec_2f:

  pop bp                            ; obnova registru
  pop bx
  pop cx
  pop dx
  pop di
  pop si
  pop es
  pop ds
  pop ax

  iret
Int2f endp
;----------------------------------------- UVOLNENI PROGRAMU Z PAMETI
uvolni proc near
  push es
  push ax

  mov al,1Ch                        ; zjistit aktualni preruseni 1Ch
  call GetInt
  cmp bx,offset Int1C               ; neni to nas program - nelze odinstalovat
  jne nejde
  mov dx,es
  mov bx,cs
  cmp dx,bx
  jne nejde

  mov al,28h                        ; podobne 28h
  call GetInt
  cmp bx,offset Int28
  jne nejde
  mov dx,es
  mov bx,cs
  cmp dx,bx
  jne nejde

  mov al,2Fh                        ; podobne 2Fh
  call GetInt
  cmp bx,offset Int2F
  jne nejde
  mov dx,es
  mov bx,cs
  cmp dx,bx
  jne nejde
                                    ; Lze odinstalovat
  mov ax,cs
  mov es,ax
  mov si,offset ECBs                ; zrusime cekani na paket a zavreme socket
  mov bx,6
  call net                          ; CancelEvent
  mov bx,1
  mov dx,Sckt1
  call Net                          ; CloseSocket

  push ds
  mov dx,cs:[ofs_1C]                ; Nastavit INT 1Ch zpet
  mov ax,cs:[seg_1C]
  mov ds,ax
  mov al,1Ch
  call SetInt

  mov dx,cs:[ofs_2F]                ; Nastavit INT 2Fh zpet
  mov ax,cs:[seg_2F]
  mov ds,ax
  mov al,2Fh
  call SetInt

  mov dx,cs:[ofs_28]                ; Nastavit INT 28h zpet
  mov ax,cs:[seg_28]
  mov ds,ax
  mov al,28h
  call SetInt

  mov ah,49h                        ; Uvolnit pametovy blok
;  mov es,mpsp
  int 21h

  pop ds
  pop ax
  pop es
  stc
  ret

Nejde:
  mov bl,al                         ; Cislo obsazeneho preruseni
  pop ax                            ;  nerezidentni cast ho vypise
  pop es
  clc
  ret
uvolni endp
;----------------------------------------- ZACATEK NEREZIDENTNI CASTI PROGRAMU
begin proc near
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT
  STEJNESEG

  mov dx,offset info                ; vypis informacniho hlaseni
  mov ah,9
  int 21h

  call InitR

  cmp byte ptr cs:[80h],2           ; primitivni test odinstalovaciho parametru
  jb normal
  cmp byte ptr cs:[82h],'U'
  je uninst
  cmp byte ptr cs:[82h],'u'
  je uninst
  cmp byte ptr cs:[80h],3
  jb normal
  cmp byte ptr cs:[83h],'U'
  je uninst
  cmp byte ptr cs:[83h],'u'
  jne normal
uninst:
  mov [un],1                        ; uschovani prikazu k odinstalovani
normal:
  call je_tam                       ; zjisteni, zda je uz nainstalovan
  jae can_install
  cmp al,1
  mov dx,offset msg5
  je nn                             ; chyba - neni volne ID pro INT 2Fh
  cmp un,1
  je odinstaluj
  mov dx,offset msg2                ; chyba - uz je nainstalovan
nn:
  jmp error

odinstaluj:                         ; posleme residentu prikaz k odistalovani
  mov ah,cs:[MY_ID]
  mov al,77h
  int 2Fh
  mov dx,offset msg7                ; pripravime si zpravu o uspechu
  cmp bx,3334h                      ; kod 3334h znamena uspech
  je L1
  mov dx,offset msg8                ; chyba - nelze odinstalovat
  mov si,offset [msg8+4]            ; vypis cisla obsazeneho preruseni
  call HexByte
L1:
  jmp error

can_install:
  cmp un,1                          ; resident neni v pameti a je prikaz k
  mov dx,offset msg6                ; odinstalovani - chyba
  je error

  mov ax,7A00h                      ; Je IPX ?
  int 2Fh
  cmp al,0FFh                       ; neni - chyba
  mov dx,offset msg3
  jne error

  mov al,0FFh                       ; Otevrit socket
  mov bx,0
  mov dx,sckt1
  call Net
  cmp al,0                          ; nelze otevrit socket - chyba
  mov dx,offset msg4                
  jne error

  mov ax,word ptr cs:[2Ch]          ; Uvolni prostredi DOSu
  mov es,ax
  mov ah,49h
  int 21h

  call prijem                       ; cekej na prvni paket

  call setints                      ; nastav preruseni

  mov dx,offset msg1                ; zprava o uspesnem nainstalovani
  call vypis

  call Random                       ; unikatni Security ID
  mov word ptr [SecNum]  ,ax
  call Random
  mov word ptr [SecNum+2],ax

  mov busy,0                        ; obsluha preruseni nepracuje

  mov ax,3100h                      ; Keep
  mov dx,size16                     ; size16 je velikost ponechana v pameti
  int 21h

error:                              ; Konec
  call vypis
  mov ax,4C01h
  int 21h

begin endp

;------------------------------------------- VYPIS RETEZCE
Vypis proc near
  mov ah,09h
  int 21h
  ret
Vypis endp

;------------------------------------------- NASTAVENI PRERUSENI
SetInts proc near
  mov al,1Ch                        ; Zjistit INT 1Ch
  call GetInt
  mov word ptr cs:[ofs_1C],bx
  mov word ptr cs:[seg_1C],es

  lea dx,Int1C                      ; Nastavit INT 1Ch
  mov al,1Ch
  call SetInt

  mov al,28h                        ; Zjistit INT 28h
  call GetInt
  mov word ptr cs:[ofs_28],bx
  mov word ptr cs:[seg_28],es

  lea dx,Int28                      ; Nastavit INT 28h
  mov al,28h
  call SetInt

  mov al,2Fh                        ; Zjistit INT 2Fh
  call GetInt
  mov word ptr cs:[ofs_2F],bx
  mov word ptr cs:[seg_2F],es

  lea dx,Int2F                      ; Nastavit INT 2Fh
  mov al,2Fh
  call SetInt
  ret
SetInts endp
;------------------------------------------- DETEKCE NAINSTALOVANEHO PROGRAMU
                                    ; vystup CF=0      -> volne, cislo ulozeno
                                    ;        CF=1 AL=1 -> neni volne cislo
                                    ;        CF=1 AL=2 -> uz je nainstalovan
je_tam proc near                    ; kopie mezi C0-CF multiplexu int 2Fh
  mov cs:[MY_ID],0CFh
search:
  cmp cs:[MY_ID],0C0h
  jbe end_je_tam
  mov ah,cs:[MY_ID]                 ; zkousim ID
  mov al,0                          ; fce 0 pro detekci
  int 2Fh
  cmp al,0FFh                       ; ID je obsazeno ?
  jne Next_ID
  cmp bx,3333h                      ; ID je obsazeno mnou ?
  je Found
Next_ID:
  cmp al,0
  jne dec_ah
  mov bl,cs:[MY_ID]
  mov cs:[Free],bl
Dec_ah:
  dec byte ptr cs:[MY_ID]
  jmp search

End_je_tam:
  cmp cs:[Free],0
  je NoNum
  jmp NoFound
NoNum:
  mov al,1
  stc
  ret
Found:
  mov al,2
  stc
  ret
NoFound:
  mov bl,cs:[Free]
  mov cs:[MY_ID],bl
  clc
  ret
je_tam endp
  Free  db  0

;------------------------------------------- VYPIS HEXADECIMALNIHO BYTU
HexByte proc near                   ; bl - cislo
  mov al,bl                         ; ds:si - 2 byty mista pro Hex hodnotu
  shr al,4
  call HexByte1
  mov ds:[si],al
  mov al,bl
  and al,0Fh
  call HexByte1
  mov ds:[si+1],al
  ret
HexByte endp

HexByte1 proc near
  add al,48
  cmp al,57
  jbe _09
  add al,7
_09:
  ret
HexByte1 endp
;------------------------------------------- GENEROVANI NAHODNYCH CISEL
  Rvalue dd 0
  RSeed  dd 0
Random proc near                    ; generuje nahodne cislo do AX
  mov bx,word ptr [RValue]
  mov ax,word ptr [RSeed]
  rol ax,3
  sub ax,7
  xor ax,bx
  mov word ptr [RValue],ax
  mov word ptr [RSeed],ax
  ret
Random endp

InitR proc near                     ; inicializuje nahodny generator
  push ax
  mov ax,0040h
  mov es,ax
  mov ax,es:[006Ch]
  mov word ptr [RSeed],ax
  mov ax,es:[006Ch+2]
  mov word ptr [RSeed+2],ax
  pop ax
  ret
InitR endp

;---------------------------------------------------------- NEREZIDENTNI DATA
  Un    db  0
  Info  db  '           Ŀ',13,10
        db  '             RES - remote control system      (C) Oto Valek       ',13,10
        db  '           ',13,10
        db  '            ','$'
  Msg1  db  'Installed',13,10,'$'
  Msg2  db  'Already installed',13,10,'$'
  Msg3  db  'No IPX driver',13,10,'$'
  Msg4  db  'Can''t open socket',13,10,'$'
  Msg5  db  'No free INT 2F number',13,10,'$'
  Msg6  db  'Not in memory - Can''t uninstall',13,10,'$'
  Msg7  db  'Succesfully uninstalled',13,10,'$'
  Msg8  db  'INT ##h vector hooked - Can''t uninstall.',13,10,'$'
;-----------------------------------------------------------------------------

program_end:
_TEXT ends
END @filename
